﻿namespace TabsStudioMarker
{
    class EnumWindowFrames
    {
        public EnumWindowFrames(EnvDTE80.DTE2 dte)
        {
            System.IServiceProvider serviceProvider = new Microsoft.VisualStudio.Shell.ServiceProvider(
		        dte as Microsoft.VisualStudio.OLE.Interop.IServiceProvider);

	        uiShell = serviceProvider.GetService(typeof(Microsoft.VisualStudio.Shell.Interop.SVsUIShell)) as
                Microsoft.VisualStudio.Shell.Interop.IVsUIShell;
        }

        public System.Collections.Generic.List<WindowFrame> GetWindowFrames()
        {
            System.Collections.Generic.List<WindowFrame> result = new System.Collections.Generic.List<WindowFrame>();
	        {
		        Microsoft.VisualStudio.Shell.Interop.IEnumWindowFrames enumFrames = null;
		        if (uiShell.GetDocumentWindowEnum(out enumFrames) == S_OK && enumFrames != null)
			        EnumWindows(enumFrames, result);
	        }
            {
                Microsoft.VisualStudio.Shell.Interop.IEnumWindowFrames enumFrames = null;
                if (uiShell.GetToolWindowEnum(out enumFrames) == S_OK && enumFrames != null)
                    EnumWindows(enumFrames, result);
            }
	        return result;
        }

        private void EnumWindows(Microsoft.VisualStudio.Shell.Interop.IEnumWindowFrames enumFrames,
                System.Collections.Generic.List<WindowFrame> result)
        {
	        if (enumFrames.Reset() != S_OK)
		        return;

	        Microsoft.VisualStudio.Shell.Interop.IVsWindowFrame[] frames = 
                new Microsoft.VisualStudio.Shell.Interop.IVsWindowFrame[1];
	        bool hasMoreWindows = true;
	        do 
	        {
		        uint fetched;
		        hasMoreWindows = enumFrames.Next(1, frames, out fetched) == S_OK && fetched == 1;
		        if (hasMoreWindows)
		        {
			        if (frames[0] == null)
				        continue;

			        object o;
			        if (frames[0].GetProperty((int)Microsoft.VisualStudio.Shell.Interop.__VSFPROPID.VSFPROPID_ExtWindowObject,
                        out o) != S_OK || o == null)
			        {
				        continue;
			        }

			        EnvDTE.Window w = o as EnvDTE.Window;
			        if (w == null)
				        continue;

			        result.Add(new WindowFrame(w, frames[0]));
		        }
	        } 
	        while (hasMoreWindows);
        }

        private	Microsoft.VisualStudio.Shell.Interop.IVsUIShell uiShell;
        private int S_OK = Microsoft.VisualStudio.VSConstants.S_OK;
    }
}
