﻿namespace TabsStudioMarker
{
    class HighlightStateSaver
    {
        public HighlightStateSaver(TabsStudioExt.ITabsStudioEngine engine_)
        {
            engine = engine_;
            highlightedWindows = new System.Collections.Generic.List<EnvDTE.Window>();
            saving = true;

            engine.TabExtensionCreated += OnExtensionCreated;
            engine.TabExtensionDestroyed += OnExtensionDestroyed;
        }

        public void Close()
        {
            engine.TabExtensionCreated -= OnExtensionCreated;
            engine.TabExtensionDestroyed -= OnExtensionDestroyed;
        }

        public bool IsHighlighted(EnvDTE.Window w)
        {
            return highlightedWindows.Contains(w);
        }

        private void OnExtensionCreated(object sender, TabsStudioExt.TabExtensionEventArgs e)
        {
            saving = false;
        }

        private void OnExtensionDestroyed(object sender, TabsStudioExt.TabExtensionEventArgs e)
        {
            if (!saving)
            {
                highlightedWindows.Clear();
                saving = true;
            }

            if (Properties.GetIsHighlighted(e.Tab.TabItem))
                highlightedWindows.Add(e.TabExtension.Window);
        }

        private TabsStudioExt.ITabsStudioEngine engine;
        private System.Collections.Generic.List<EnvDTE.Window> highlightedWindows;
        private bool saving;
    }
}
